/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.olingo.fit.proxy.staticservice.microsoft.test.odata.services.odatawcfservice.types;

// CHECKSTYLE:OFF (Maven checkstyle)
import java.util.Collection;
// CHECKSTYLE:ON (Maven checkstyle)

import org.apache.olingo.ext.proxy.api.AbstractTerm;
import org.apache.olingo.ext.proxy.api.OperationType;
import org.apache.olingo.ext.proxy.api.annotations.Parameter;

public interface ProductCollection
    extends
    org.apache.olingo.ext.proxy.api.StructuredCollectionQuery<ProductCollection>,
org.apache.olingo.ext.proxy.api.EntityCollection<Product, ProductCollection, ProductCollection> {

  Operations operations();

  interface Operations extends org.apache.olingo.ext.proxy.api.Operations {

    @org.apache.olingo.ext.proxy.api.annotations.Operation(
        name = "Discount",
        type = OperationType.ACTION,
        referenceType = ProductCollection.class,
        returnType = "Collection(Microsoft.Test.OData.Services.ODataWCFService.Product)")
        org.apache.olingo.ext.proxy.api.StructuredCollectionInvoker<ProductCollection>
        discount(
            @Parameter(name = "percentage", type = "Edm.Int32", nullable = false) java.lang.Integer percentage
        );

  }

  Object getAnnotation(Class<? extends AbstractTerm> term);

  Collection<Class<? extends AbstractTerm>> getAnnotationTerms();
}
